"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts_simple_ast_1 = require("ts-simple-ast");
var argumenter_1 = require("@joejukan/argumenter");
var ASTFinder = /** @class */ (function () {
    function ASTFinder() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var argue = new argumenter_1.Argumenter(args);
        this.source = argue.instance(ts_simple_ast_1.SourceFile);
    }
    ASTFinder.prototype.findVariableDeclaration = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var argue = new argumenter_1.Argumenter(args);
        var source = this.source;
        var name = argue.string;
        var ctor = argue.function;
        if (ctor && !name) {
            name = ctor.name;
        }
        if (source) {
            var statements = source.getVariableStatements();
            if (statements) {
                for (var i = 0; i < statements.length; i++) {
                    var declarations = statements[i].getDeclarations();
                    if (declarations) {
                        for (var j = 0; j < declarations.length; j++) {
                            var declaration = declarations[j];
                            var type = declaration.getType();
                            if (type) {
                                var symbol = type.getSymbol() || type.getAliasSymbol();
                                if (symbol && symbol.getName() === name) {
                                    return declaration;
                                }
                            }
                        }
                    }
                }
            }
        }
        return undefined;
    };
    return ASTFinder;
}());
exports.ASTFinder = ASTFinder;
//# sourceMappingURL=ast.finder.js.map